# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

bl_info = {
    "name": "Object Linker",
    "author": "rubberduck",
    "version": (0, 1),
    "blender": (2, 69, 0),
    "location": "--",
    "description": "--",
    "warning": "",
#    "wiki_url": "--"
#                "--",
    "category": "Object"}



if "bpy" in locals():
    import imp
    imp.reload(object_linker)
else:
	from . import object_linker


import os

default_filepath = os.path.dirname(__file__)

from bpy.props import *
import bpy

class Update_List(bpy.types.Operator):
	bl_idname = "ops.updatelist"
	bl_label = "update list"
 
	def execute(self, context):
		
		print ("updated")
		object_linker.dir_path_update(self, context)
			
		return{'FINISHED'} 

class LinkAppendObject(bpy.types.Operator):
	bl_idname = "ops.linkappend"
	bl_label = "Link/ Append Object"
 
	def execute(self, context):
		
		object_link = object_linker.get_object_value(context.scene.game_object, "OBJECT")[0]
		if object_link != "no_value_found":
			print (object_link)
			ob = object_linker.get_object_value(context.scene.game_object, "OBJECT")[0]
			folder = object_linker.get_object_value(context.scene.game_object, "FOLDER")[0]
			blend_dir = context.scene.choose_path + folder + "/"
			blend_path = "objects.blend/Object/"
			if context.scene.checkbox_link == True:


				bpy.ops.wm.link_append(filepath = "//" + blend_path + ob, filename = ob, directory = blend_dir + blend_path, active_layer = True)
				bpy.ops.object.make_local(type='SELECT_OBJECT')
				

			else:

				bpy.ops.wm.link_append(filepath = "//" + blend_path + ob, filename = ob, directory = blend_dir + blend_path, active_layer = True)
				bpy.ops.object.make_local(type='ALL')
			bpy.ops.view3d.snap_selected_to_cursor(use_offset=True)
			bpy.context.scene.objects.active = bpy.context.selected_objects[0]

			
		return{'FINISHED'}   

class ObjectPlacerPanel(bpy.types.Panel):
	bl_label = "ObjectLinker"
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'TOOLS'


	def draw(self, context):
		layout = self.layout
		scn = context.scene
		row = layout.row()
		object_linker.make_list(context.scene.choose_path)

		
		row2 = layout.row()
		
		col = layout.column()

		
		col.operator("ops.updatelist")
		col.prop(context.scene, 'choose_path')
#		col.label(context.scene.choose_path)
		col.prop_search(context.scene, "game_object", context.scene, "coll", text = "Object")
#		col.label(str(object_linker.category_list))
		col.prop(context.scene, 'sel_category')
#		col.label(context.scene.choose_path + "/testset/images/test_image.png")
		infobox = col.box()
		selected = context.scene.game_object
		if selected == "":
			selected = "none"
		infobox.label("Selected: " + selected)

		image_name = object_linker.get_object_value(context.scene.game_object, "IMAGE")[0]
		if image_name == "no_value_found":
			image_name = "no image found"
		infobox.label("Image: " + image_name)
		
		categories = object_linker.get_object_value(context.scene.game_object, "CATEGORY")
		categories = ", ".join(categories)
		if categories == "no_value_found":
			categories = "no categories found"
		infobox.label("Categories: " + categories)
		col.prop(context.scene, "checkbox_link")
		col.operator("ops.linkappend")



def register():

	bpy.utils.register_module(__name__)

	bpy.types.Scene.coll = bpy.props.CollectionProperty(
	type=bpy.types.PropertyGroup
	)
	


	bpy.types.Scene.choose_path = bpy.props.StringProperty(update = object_linker.dir_path_update, name="file path",
	
	attr="custompath",# this a variable that will set or get from the scene
	maxlen= 1024,
	subtype='DIR_PATH',
	default= default_filepath + "/"
	)
	bpy.types.Scene.sel_category = bpy.props.EnumProperty(update = object_linker.category_choose, name = "Category", items = 	object_linker.list_populate)

	bpy.types.Scene.game_object = bpy.props.StringProperty(update = object_linker.object_choose)
	bpy.types.Scene.select_category = bpy.props.StringProperty()
	bpy.types.Scene.checkbox_link = bpy.props.BoolProperty(name = "Link from Scene", default = True)

	bpy.app.handlers.scene_update_pre.append(object_linker.populate_coll)
	
	



def unregister():
	bpy.utils.unregister_module(__name__)
	

	del bpy.types.Scene.coll
	del bpy.types.Scene.choose_path
	del bpy.types.Scene.game_object
	del bpy.types.Scene.select_category
	del bpy.types.Scene.sel_category
	del bpy.types.Scene.checkbox_link

	
	
	

if __name__ == "__main__":
	register()

